﻿Public Class XISCKER_ASM
    'Note: The "%" char means an error occurred
    Dim EQUarray(1000, 0 To 1) As String
    Dim OffsetAddress As Int16 = 256
    Dim EQUcounter As Int16 = 0
    Dim ErrorCounter As Int16 = 0
    Dim MemoryAddressCounter As Int16 = 0
    Dim LabelField As String = "%"
    Dim LabelArray(1000, 0 To 1) As String

    'Shared Instruction fields
    Dim OperationField As String = "%"
    Dim OperandField As String = "%"

    'To Split Instruction Fields
    Dim InstructionRigth As String = "%"
    Dim InstructionLeft As String = "%"
    Dim InstructionsVector() As String
    'To build a machine code
    Dim OperandInByte(0 To 1)       'operand(0)=>Low Byte, operand(1)=>High Byte
    Dim MachineCode(0 To 16383) As String

    'To save file
    Dim FileNameAssembler As String = ""
    Dim FileNameMemory As String = ""
    Dim SaveMemoryFile As Boolean = True
    Public Shared WorkSpaceFolder = ""
    Public Shared IsCISCKER As Boolean = True

    'User GUI

    Private Sub SaveAsmSession()

        Dim session As String = FileNameAssembler & vbNewLine & FileNameMemory & vbNewLine & ToolButton_CISCKER.Checked & vbNewLine & WorkSpaceFolder

        WriteFile(WorkSpaceFolder & "\sys\LastAsmSession.bak", session)

        WriteFile("C:\XISCKER\LastWorkSpaceFolder.txt", WorkSpaceFolder)

    End Sub

    Private Sub LoadWorkSpace()

        FolderBrowserDialog_WorkSpace.Description = " Select your Work Space Folder "
        FolderBrowserDialog_WorkSpace.ShowDialog()
        WorkSpaceFolder = FolderBrowserDialog_WorkSpace.SelectedPath
        ToolTextBox_WorkSpace.Text = WorkSpaceFolder

        If (Not System.IO.Directory.Exists(WorkSpaceFolder & "\sys")) Then
            My.Computer.FileSystem.CreateDirectory(WorkSpaceFolder & "\sys")
        End If

    End Sub

    Private Sub LoadAsmSession()
        Dim session() As String

        Try
            session = Split(ReadFile(WorkSpaceFolder & "\sys\LastAsmSession.bak"), vbNewLine)

            FileNameAssembler = session(0)
            Me.Text = "X-ISCKER ASM - " & FileNameAssembler
            TextBox_Assembler.Text = ReadFile(FileNameAssembler)

            FileNameMemory = session(1)
            TextBox_MemoryPath.Text = FileNameMemory
            TextBox_MIF.Text = ReadFile(FileNameMemory)

            If session(2) = "True" Then
                ToolButton_CISCKER.PerformClick()
            Else
                ToolButton_RISCKER.PerformClick()
            End If

            WorkSpaceFolder = session(3)

        Catch ex As Exception
            SaveAsmSession()
        End Try

    End Sub

    Private Sub XISCKER_ASM_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.FormClosing
        'Ask for save xhanges before closing
        Dim result As DialogResult
        result = MessageBox.Show("Do you want to save your changes?", "Save Changes", MessageBoxButtons.YesNoCancel)
        If result = System.Windows.Forms.DialogResult.Yes Then
            SaveFileSubroutine(FileNameMemory, FileNameAssembler)

            If FileNameMemory = "" Or FileNameAssembler = "" Then
                e.Cancel = True
            End If


        ElseIf result = System.Windows.Forms.DialogResult.Cancel Then
            e.Cancel = True
        End If
        'Save the assembler in a txt file to load when the program is open
        SaveAsmSession()

    End Sub

    Private Sub XISCKER_ASM_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown
        'To detect Hot Keys
        If e.KeyCode = Keys.F5 Then
            ToolButton_Run.PerformClick()
        ElseIf e.KeyCode = Keys.S AndAlso (e.Control) Then
            SaveFileSubroutine(FileNameMemory, FileNameAssembler)
        ElseIf e.KeyCode = Keys.O AndAlso (e.Control) Then
            ToolButton_OpenNewFile.PerformButtonClick()
        ElseIf e.KeyCode = Keys.P AndAlso (e.Control) Or e.KeyCode = Keys.F7 Then
            ToolButton_Programmer.PerformClick()
        ElseIf e.KeyCode = Keys.F8 Then
            XISCKER_Programmer.Button_Program.PerformClick()
        ElseIf e.KeyCode = Keys.D0 AndAlso (e.Control) Or e.KeyCode = Keys.F6 Then
            ToolButton_Observer.PerformClick()
        ElseIf e.KeyCode = Keys.N AndAlso (e.Control) Then
            NewBlankFileToolStripMenuItem.PerformClick()
        ElseIf e.KeyCode = Keys.F3 Then
            ToolButton_RISCKER.PerformClick()
        ElseIf e.KeyCode = Keys.F4 Then
            ToolButton_CISCKER.PerformClick()
        End If
    End Sub

    Private Sub XISCKER_ASM_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load


        Try
            WorkSpaceFolder = ReadFile("C:\XISCKER\LastWorkSpaceFolder.txt")
            ToolTextBox_WorkSpace.Text = WorkSpaceFolder
        Catch ex As Exception

            If (Not System.IO.Directory.Exists("C:\XISCKER")) Then
                My.Computer.FileSystem.CreateDirectory("C:\XISCKER")
            End If

            'Load the Work Space folder
            LoadWorkSpace()

            WriteFile("C:\XISCKER\LastWorkSpaceFolder.txt", WorkSpaceFolder)

        End Try


        'Load the last assembler code
        LoadAsmSession()

        'Key preview enabled, to detect the special keys
        Me.KeyPreview = True
    End Sub

    Public Sub WriteFile(ByRef FileName As String, ByRef StringToWrite As String)
        'write the content of StringToWrite in a file located in FileName
        Dim Writer As New IO.StreamWriter(FileName)
        Writer.Write(StringToWrite)
        Writer.Close()
    End Sub

    Public Function ReadFile(ByRef FileName As String) As String
        'Return the content of the file located in FileName
        Dim Reader As New IO.StreamReader(FileName)
        ReadFile = Reader.ReadToEnd()
        Reader.Close()
    End Function

    Private Sub FileToolMenuItem_MachineCode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolMenuItem_MemoryIni.Click
        MemorySaveFileClick()
    End Sub

    Public Sub MemorySaveFileClick()
        'Set and show the save file dialog for memory textbox
        SaveMemoryFile = True

        SaveFileDialog1.FileName = "instructions"

        If ToolButton_Quartus.Checked = True Then

            SaveFileDialog1.Filter = "MIF Files (*.mif)|*.mif"
            SaveFileDialog1.DefaultExt = ".mif"
            SaveFileDialog1.Title = "Save a MIF File for Instruction's ROM - X-ISCKER"
            SaveFileDialog1.ShowDialog()

        Else
            SaveFileDialog1.Filter = "MEM Files (*.mem)|*.mem"
            SaveFileDialog1.DefaultExt = ".mem"
            SaveFileDialog1.Title = "Save a MEM File for Instruction's ROM - X-ISCKER"
            SaveFileDialog1.ShowDialog()

        End If



    End Sub

    Private Sub ToolMenuItem_AssemblyFile_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolMenuItem_AssemblyFile.Click
        AssemblySaveFileClick()
    End Sub

    Public Sub AssemblySaveFileClick()
        'set and show the save file dialog for assembler textbox
        SaveMemoryFile = False
        SaveFileDialog1.InitialDirectory = WorkSpaceFolder
        SaveFileDialog1.FileName = FileNameAssembler


        If ToolButton_CISCKER.Checked = True Then
            SaveFileDialog1.Filter = "ckr Files (*.ckr)|*.ckr"
            SaveFileDialog1.DefaultExt = ".ckr"
            SaveFileDialog1.Title = "Save Assembler File for Instruction's ROM - CISCKER"
            SaveFileDialog1.ShowDialog()
        Else
            SaveFileDialog1.Filter = "rkr Files (*.rkr)|*.rkr"
            SaveFileDialog1.DefaultExt = ".rkr"
            SaveFileDialog1.Title = "Save Assembler File for Instruction's ROM - RISCKER"
            SaveFileDialog1.ShowDialog()
        End If
    End Sub

    Private Sub ToolButton_SaveFile_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_SaveFile.ButtonClick
        SaveFileSubroutine(FileNameMemory, FileNameAssembler)
    End Sub

    Public Sub SaveFileSubroutine(ByRef FileNameMemory As String, ByRef FileNameAssembler As String)
        'check if filenames (memory and assembler) are blank, and save the files
        'if the filenames are loaded then save the files inmmidiatly


        If FileNameAssembler = "" Then
            AssemblySaveFileClick()
        End If

        If FileNameMemory = "" Then
            MemorySaveFileClick()
        End If

        If FileNameMemory = "" Or FileNameAssembler = "" Then
            Exit Sub
        Else
            'write assembler file
            WriteFile(FileNameAssembler, TextBox_Assembler.Text)

            'write memory file
            WriteFile(FileNameMemory, TextBox_MIF.Text)
        End If

    End Sub

    Private Sub SaveFileDialog1_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        'Get the file name and save the proper file
        If SaveMemoryFile = True Then
            FileNameMemory = SaveFileDialog1.FileName
            WriteFile(FileNameMemory, TextBox_MIF.Text)
            TextBox_MemoryPath.Text = FileNameMemory
        Else
            FileNameAssembler = SaveFileDialog1.FileName
            WriteFile(SaveFileDialog1.FileName, TextBox_Assembler.Text)
            Me.Text = "X-ISCKER - " & FileNameAssembler
        End If
    End Sub

    Private Sub OpenFileDialog1_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        'Load the assemblertext box with the selected file to open
        FileNameAssembler = OpenFileDialog1.FileName
        TextBox_Assembler.Text = ReadFile(FileNameAssembler)
        Me.Text = "X-ISCKER ASM - " & FileNameAssembler

    End Sub

    Private Sub NewCISCKERASMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewCISCKERASMToolStripMenuItem.Click
        'Open a Ciscker ASM file
        OpenFileDialog1.InitialDirectory = WorkSpaceFolder
        'Check the ciscker button
        ToolButton_RISCKER.Checked = False
        ToolButton_CISCKER.Checked = True
        'launch the open file dialog for ckr files
        OpenFileDialog1.Filter = "ckr Files (*.ckr)|*.ckr"
        OpenFileDialog1.DefaultExt = ".ckr"
        OpenFileDialog1.Title = "Open Assembler File for Instruction's ROM - CISCKER"
        OpenFileDialog1.FileName = "OpenAssemblerFile"
        OpenFileDialog1.ShowDialog()
    End Sub

    Private Sub NewRISCKERASMToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewRISCKERASMToolStripMenuItem.Click
        'Open a Riscker ASM file
        OpenFileDialog1.InitialDirectory = WorkSpaceFolder
        'Check the riscker button
        ToolButton_RISCKER.Checked = True
        ToolButton_CISCKER.Checked = False
        'launch the open file dialog for rkr files
        OpenFileDialog1.Filter = "rkr Files (*.rkr)|*.rkr"
        OpenFileDialog1.DefaultExt = ".rkr"
        OpenFileDialog1.Title = "Open Assembler File for Instruction's ROM - RISCKER"
        OpenFileDialog1.FileName = "OpenAssemblerFile"
        OpenFileDialog1.ShowDialog()
    End Sub

    Private Sub ToolButton_OpenNewFile_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_OpenNewFile.ButtonClick
        OpenFileDialog1.InitialDirectory = WorkSpaceFolder
        'launch the open file dialog for all files
        OpenFileDialog1.Filter = "All files (*.*)|*.*|CISCKER Files (*.ckr)|*.ckr|RISCKER Files (*.rkr)|*.rkr|Text files (*.txt)|*.txt"
        OpenFileDialog1.DefaultExt = "*.*"
        OpenFileDialog1.Title = "Open Assembler File for Instruction's ROM - X-ISCKER"
        OpenFileDialog1.FileName = "OpenAssemblerFile"
        OpenFileDialog1.ShowDialog()
    End Sub

    Private Sub NewBlankFileToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewBlankFileToolStripMenuItem.Click
        'Clear all textboxes and program variables
        Dim result As DialogResult
        'ask for save changes
        result = MessageBox.Show("Do you want to save your changes?", "Save Changes", MessageBoxButtons.YesNoCancel)
        If result = System.Windows.Forms.DialogResult.Yes Then
            SaveFileSubroutine(FileNameMemory, FileNameAssembler)
        ElseIf result = System.Windows.Forms.DialogResult.Cancel Then
            Exit Sub
        End If
        'clear all data
        ClearAllTexBoxAndVars()
        TextBox_Assembler.Clear()
        FileNameAssembler = ""
        Me.Text = "X-ISCKER ASM - " & FileNameAssembler
        FileNameMemory = ""
        TextBox_MemoryPath.Text = FileNameMemory
    End Sub

    Private Sub ToolButton_CISCKER_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_CISCKER.Click
        'Check the Ciscker assembly process
        ToolButton_CISCKER.Checked = True
        ToolButton_RISCKER.Checked = False
    End Sub

    Private Sub ToolButton_RISCKER_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_RISCKER.Click
        'Check the Riscker assembly process
        ToolButton_RISCKER.Checked = True
        ToolButton_CISCKER.Checked = False
    End Sub

    Private Sub WikiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WikiToolStripMenuItem.Click
        'link to wiki webpage
        System.Diagnostics.Process.Start("http://semilleroadt.upbbga.edu.co/xiscker/")
    End Sub

    Private Sub ToolButton_Quartus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_Quartus.Click
        ToolButton_Quartus.Checked = True
        ToolButton_ISE.Checked = False
    End Sub

    Private Sub ToolButton_ISE_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_ISE.Click
        ToolButton_Quartus.Checked = False
        ToolButton_ISE.Checked = True
    End Sub


    'Assembly program

    Public Function CheckAddressingMode(ByVal opr As String)

        'To check INH, REL, EXT implicit addressign modes

        'Returns    
        '           R if Operation is RELATIVE
        '           J if Operation is EXT only
        '           k if Operation is 16 bit
        '           % others

        CheckAddressingMode = "%"
        opr = UCase(opr)
        Select Case opr

            'RELATIVE OPERATIONS
            Case "DABNZ"
                CheckAddressingMode = "R"


            Case "DBBNZ"
                CheckAddressingMode = "R"


            Case "BRN"
                CheckAddressingMode = "R"


            Case "BRA"
                CheckAddressingMode = "R"


            Case "BIL"
                CheckAddressingMode = "R"


            Case "BIH"
                CheckAddressingMode = "R"

            Case "BHCC"
                CheckAddressingMode = "R"


            Case "BHCS"
                CheckAddressingMode = "R"


            Case "BHI"
                CheckAddressingMode = "R"


            Case "BLS"
                CheckAddressingMode = "R"


            Case "BCC"
                CheckAddressingMode = "R"


            Case "BCS"
                CheckAddressingMode = "R"


            Case "BNE"
                CheckAddressingMode = "R"


            Case "BEQ"
                CheckAddressingMode = "R"


            Case "BVC"
                CheckAddressingMode = "R"


            Case "BVS"
                CheckAddressingMode = "R"


            Case "BPL"
                CheckAddressingMode = "R"


            Case "BMI"
                CheckAddressingMode = "R"


            Case "BGE"
                CheckAddressingMode = "R"


            Case "BLT"
                CheckAddressingMode = "R"


            Case "BGT"
                CheckAddressingMode = "R"


            Case "BLE"
                CheckAddressingMode = "R"

                '16 BIT OPERATIONS
            Case "AIS"
                CheckAddressingMode = "K"

            Case "SUBD"
                CheckAddressingMode = "K"

            Case "ADDD"
                CheckAddressingMode = "K"

            Case "LDS"
                CheckAddressingMode = "K"

            Case "AIX"
                CheckAddressingMode = "K"

            Case "CPX"
                CheckAddressingMode = "K"

            Case "LDX"
                CheckAddressingMode = "K"

            Case "CPD"
                CheckAddressingMode = "K"

            Case "LDD"
                CheckAddressingMode = "K"

                'ONLY EXT OPERANDS
            Case "NEG"
                CheckAddressingMode = "J"

            Case "CLR"
                CheckAddressingMode = "J"

            Case "INC"
                CheckAddressingMode = "J"

            Case "DEC"
                CheckAddressingMode = "J"

            Case "LSR"
                CheckAddressingMode = "J"

            Case "ROR"
                CheckAddressingMode = "J"

            Case "ASR"
                CheckAddressingMode = "J"

            Case "LSL"
                CheckAddressingMode = "J"

            Case "ROL"
                CheckAddressingMode = "J"

            Case "TST"
                CheckAddressingMode = "J"

            Case "BCLR"
                CheckAddressingMode = "J"

            Case "BSET"
                CheckAddressingMode = "J"

            Case "MOV"
                CheckAddressingMode = "J"

            Case "JMP"
                CheckAddressingMode = "J"

        End Select

    End Function

    Public Function TrimLinesWhithoutOperations(ByVal text() As String)

        'Returns a vector without empty lines, comments lines or directives.
        'Resolve the directives

        Dim line_counter As Int16 = 0
        Dim include() As String
        Dim line As String = ""

        'Count empty lines, comments lines and resolve directives to estimate the length of the new vector
        Dim number As Int16
        For i = 0 To text.Length - 1
            text(i) = Trim(Replace(text(i), vbTab, " "))
            If text(i) = "" Then               ' empty lines
                number = number + 1
            ElseIf text(i).First = ";" Then    ' comments lines
                number = number + 1
            ElseIf text(i).First = "." Then    ' directves
                number = number + 1
            End If
        Next

        'Create a new vector, it will contains operations lines only
        Dim OperationsOnly(text.Length - 1 - number) As String
        'TextBox_Summary.Text = "Total Lines = " & text.Length & vbNewLine & "Empty Lines = " & number & vbNewLine & "Instructions Lines = " & OperationsOnly.Length & vbNewLine

        'Trim proces, fill the new vector
        For j = 0 To text.Length - 1
            If text(j) = "" Then

            ElseIf text(j).First = ";" Then 'check for empty lines


            ElseIf text(j).First = "." Then ' check for directive lines

                line = directives(text(j))

                If line <> "" Then
                    include = Split(line, vbCrLf)
                    ReDim OperationsOnly(text.Length - 1 - number + include.Length)
                    For i = 0 To include.Length - 1
                        OperationsOnly(line_counter) = include(i)
                        line_counter = line_counter + 1
                    Next

                End If

            Else
                OperationsOnly(line_counter) = text(j) 'save in new line
                line_counter = line_counter + 1
            End If
        Next

        'check if new vector is empty
        If line_counter = 0 Then
            TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "No code in file, please check if your source file is empty"
            ErrorCounter = ErrorCounter + 1

            Return "%"
        End If

        Return OperationsOnly
    End Function

    Private Sub updateEQUarray(ByRef Command As String, ByRef operand As String)

        If EQUcounter > 0 Then
            For i = 0 To EQUcounter - 1
                If Command = EQUarray(i, 0) Then
                    TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "EQU Label " & Command & " is duplicate"
                    ErrorCounter = ErrorCounter + 1
                    ErrorTab.Text = "Error (" & ErrorCounter & ")"
                    System.Media.SystemSounds.Hand.Play()
                    MessageBox.Show("Epic Fail", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Exit Sub
                End If
            Next
        End If

        EQUarray(EQUcounter, 0) = Command 'Label
        EQUarray(EQUcounter, 1) = operand 'Value
        EQUcounter = EQUcounter + 1

    End Sub

    Public Function directives(ByVal line As String) As String

        'Fill the EQUarray whit respectives labels and values

        Dim Directive As String = "%"
        Dim Command As String = "%"
        Dim operand As String = "%"

        directives = ""

        SplitInstructionField(line, Command, ";")

        Directive = UCase(SplitInstructionField(line, Command, " "))

        Command = SplitInstructionField(Command, operand, " ", , operand)

        Select Case (Directive)
            Case ".EQU"
                'Check for duplicate EQU labels
                updateEQUarray(Command, operand)

            Case ".ORG"
                Try
                    OffsetAddress = NumericalBase(Command, True)
                Catch ex As Exception
                    TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Operand " & OffsetAddress & " is not a proper value"
                    ErrorCounter = ErrorCounter + 1
                End Try


            Case ".INCLUDE"
                If LCase(Command) = "lib" Then
                    Dim addEQU()

                    addEQU = Split(ReadFile(WorkSpaceFolder & "\" & operand), vbNewLine)

                    For i = 0 To addEQU.Length - 1
                        Command = SplitInstructionField(addEQU(i), operand, " ", , operand)
                        updateEQUarray(Command, operand)
                    Next

                ElseIf LCase(Command) = "asm" Then
                    directives = ReadFile(WorkSpaceFolder & "\" & operand)
                End If


            Case Else
                TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Expecting an available directive"
                ErrorCounter = ErrorCounter + 1

        End Select

    End Function

    Public Function HexToTwoBytes(ByVal opr As String)

        'Returns low byte and high byte of opr in a vector
        ' operand(0)= low byte
        ' operand(1)= high byte
        'opr must be a string of hex value

        Dim operand(0 To 1)
        If opr = "" Then
            operand(0) = ""
            operand(1) = ""
        Else
            Select Case (opr.Length)
                Case 1
                    operand(0) = "0" & opr.Last
                    operand(1) = "00"
                Case 2
                    operand(0) = opr.Chars(opr.Length - 2) & opr.Last
                    operand(1) = "00"
                Case 3
                    operand(0) = opr.Chars(opr.Length - 2) & opr.Last
                    operand(1) = "0" & opr.Chars(opr.Length - 3)

                Case Else
                    operand(0) = opr.Chars(opr.Length - 2) & opr.Last
                    operand(1) = opr.Chars(opr.Length - 4) & opr.Chars(opr.Length - 3)
            End Select
        End If
        Return operand
    End Function

    Public Function OpcodeToHEX(ByVal asm_opcode As String, ByVal address_mode As String) As String

        'Return the respective hexa of the specific "opcode, addressing mode"

        asm_opcode = UCase(asm_opcode)      'Only Uppercase
        address_mode = UCase(address_mode)  'Only Uppercase
        OpcodeToHEX = "%"                 'Defaul value, for debug

        Select Case asm_opcode

            Case "NOP"
                OpcodeToHEX = "00000000"


            Case "STOP"
                OpcodeToHEX = "00000001"


            Case "DABNZ"
                OpcodeToHEX = "00000010"


            Case "DBBNZ"
                OpcodeToHEX = "00000011"


            Case "BRN"
                OpcodeToHEX = "00000100"


            Case "BRA"
                OpcodeToHEX = "00000101"


            Case "BIL"
                OpcodeToHEX = "00000110"


            Case "BIH"
                OpcodeToHEX = "00000111"


            Case "IDIV"
                OpcodeToHEX = "00001000"


            Case "MUL"
                OpcodeToHEX = "00001001"


            Case "CLV"
                OpcodeToHEX = "00001010"


            Case "SEV"
                OpcodeToHEX = "00001011"


            Case "CLC"
                OpcodeToHEX = "00001100"


            Case "SEC"
                OpcodeToHEX = "00001101"


            Case "CLI"
                OpcodeToHEX = "00001110"


            Case "SEI"
                OpcodeToHEX = "00001111"


            Case "BHCC"
                OpcodeToHEX = "00010000"


            Case "BHCS"
                OpcodeToHEX = "00010001"


            Case "BHI"
                OpcodeToHEX = "00010010"


            Case "BLS"
                OpcodeToHEX = "00010011"


            Case "BCC"
                OpcodeToHEX = "00010100"


            Case "BCS"
                OpcodeToHEX = "00010101"


            Case "BNE"
                OpcodeToHEX = "00010110"


            Case "BEQ"
                OpcodeToHEX = "00010111"


            Case "BVC"
                OpcodeToHEX = "00011000"


            Case "BVS"
                OpcodeToHEX = "00011001"


            Case "BPL"
                OpcodeToHEX = "00011010"


            Case "BMI"
                OpcodeToHEX = "00011011"


            Case "BGE"
                OpcodeToHEX = "00011100"


            Case "BLT"
                OpcodeToHEX = "00011101"


            Case "BGT"
                OpcodeToHEX = "00011110"


            Case "BLE"
                OpcodeToHEX = "00011111"


            Case "TSX"
                OpcodeToHEX = "00100000"


            Case "TXS"
                OpcodeToHEX = "00100001"


            Case "INS"
                OpcodeToHEX = "00100010"


            Case "DES"
                OpcodeToHEX = "00100011"


            Case "INX"
                OpcodeToHEX = "00100100"


            Case "DEX"
                OpcodeToHEX = "00100101"


            Case "PULX"
                OpcodeToHEX = "00100110"


            Case "PSHX"
                OpcodeToHEX = "00100111"


            Case "PULA"
                OpcodeToHEX = "00101000"

            Case "PULB"
                OpcodeToHEX = "00101001"

            Case "PUSHA"
                OpcodeToHEX = "00101010"

            Case "PSHB"
                OpcodeToHEX = "00101011"

            Case "RTS"
                OpcodeToHEX = "00101100"

            Case "RTI"
                OpcodeToHEX = "00101101"

            Case "WAIT"
                OpcodeToHEX = "00101110"

            Case "SWI"
                OpcodeToHEX = "00101111"

            Case "NEGA"
                OpcodeToHEX = "00110000"

            Case "CLRA"
                OpcodeToHEX = "00110001"

            Case "INCA"
                OpcodeToHEX = "00110010"

            Case "DECA"
                OpcodeToHEX = "00110011"

            Case "LSRA"
                OpcodeToHEX = "00110100"

            Case "RORA"
                OpcodeToHEX = "00110101"

            Case "ASRA"
                OpcodeToHEX = "00110110"

            Case "LSLA"
                OpcodeToHEX = "00110111"

            Case "ROLA"
                OpcodeToHEX = "00111000"

            Case "TSTA"
                OpcodeToHEX = "00111001"

            Case "TDX"
                OpcodeToHEX = "00111010"

                'Case "---"
                '   opcode_in_hex = "00111011"

            Case "TBA"
                OpcodeToHEX = "00111100"

                'Case "---"
                '    opcode_in_hex = "00111101"

            Case "SBA"
                OpcodeToHEX = "00111110"

            Case "ABA"
                OpcodeToHEX = "00111111"

            Case "NEGB"
                OpcodeToHEX = "01000000"

            Case "CLRB"
                OpcodeToHEX = "01000001"

            Case "INCB"
                OpcodeToHEX = "01000010"

            Case "DECB"
                OpcodeToHEX = "01000011"

            Case "LSRB"
                OpcodeToHEX = "01000100"

            Case "RORB"
                OpcodeToHEX = "01000101"

            Case "ASRB"
                OpcodeToHEX = "01000110"

            Case "LSLB"
                OpcodeToHEX = "01000111"

            Case "ROLB"
                OpcodeToHEX = "01001000"

            Case "TSTB"
                OpcodeToHEX = "01001001"

                'Case "---"
                '    opcode_in_hex = "01001010"

                'Case "NEGB"
                '    opcode_in_hex = "01001011"

            Case "TAB"
                OpcodeToHEX = "01001100"

                'Case "---"
                '    opcode_in_hex = "01001101"

            Case "CBA"
                OpcodeToHEX = "01001110"

                'Case "---"
                '    opcode_in_hex = "01001111"	

            Case "NEG"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010000"
                Else
                    OpcodeToHEX = "01100000"
                End If

            Case "CLR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010001"
                Else 'EXT
                    OpcodeToHEX = "01100001"
                End If

            Case "INC"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010010"
                Else 'EXT
                    OpcodeToHEX = "01100010"
                End If

            Case "DEC"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010011"
                Else 'EXT
                    OpcodeToHEX = "01100011"
                End If

            Case "LSR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010100"
                Else 'EXT
                    OpcodeToHEX = "01100100"
                End If

            Case "ROR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010101"
                Else 'EXT
                    OpcodeToHEX = "01100101"
                End If

            Case "ASR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010110"
                Else 'EXT
                    OpcodeToHEX = "01100110"
                End If

            Case "LSL"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01010111"
                Else 'EXT
                    OpcodeToHEX = "01100111"
                End If

            Case "ROL"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011000"
                Else 'EXT
                    OpcodeToHEX = "01101000"
                End If

            Case "TST"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011001"
                Else 'EXT
                    OpcodeToHEX = "01101001"
                End If

            Case "BRSET"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011010"
                Else 'EXT
                    OpcodeToHEX = "01101010"
                End If

            Case "BRCLR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011011"
                Else 'EXT
                    OpcodeToHEX = "01101011"
                End If

            Case "BCLR"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011100"
                Else 'EXT
                    OpcodeToHEX = "01101100"
                End If

            Case "BSET"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011101"
                Else 'EXT
                    OpcodeToHEX = "01101101"
                End If

            Case "MOV"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011110"
                Else 'EXT
                    OpcodeToHEX = "01101110"
                End If

            Case "JMP"
                If address_mode = "IX" Then
                    OpcodeToHEX = "01011111"
                Else 'EXT
                    OpcodeToHEX = "01101111"
                End If

            Case "SUBA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110000"
                    Case "IMM"
                        OpcodeToHEX = "10000000"
                    Case "DIR"
                        OpcodeToHEX = "10010000"
                    Case "IX"
                        OpcodeToHEX = "10100000"
                    Case "EXT"
                        OpcodeToHEX = "10110000"
                End Select

            Case "SBCA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110001"
                    Case "IMM"
                        OpcodeToHEX = "10000001"
                    Case "DIR"
                        OpcodeToHEX = "10010001"
                    Case "IX"
                        OpcodeToHEX = "10100001"
                    Case "EXT"
                        OpcodeToHEX = "10110001"
                End Select

            Case "ADDA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110010"
                    Case "IMM"
                        OpcodeToHEX = "10000010"
                    Case "DIR"
                        OpcodeToHEX = "10010010"
                    Case "IX"
                        OpcodeToHEX = "10100010"
                    Case "EXT"
                        OpcodeToHEX = "10110010"
                End Select

            Case "ANDA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110011"
                    Case "IMM"
                        OpcodeToHEX = "10000011"
                    Case "DIR"
                        OpcodeToHEX = "10010011"
                    Case "IX"
                        OpcodeToHEX = "10100011"
                    Case "EXT"
                        OpcodeToHEX = "10110011"
                End Select

            Case "LDA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110100"
                    Case "IMM"
                        OpcodeToHEX = "10000100"
                    Case "DIR"
                        OpcodeToHEX = "10010100"
                    Case "IX"
                        OpcodeToHEX = "10100100"
                    Case "EXT"
                        OpcodeToHEX = "10110100"
                End Select

            Case "ORA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110101"
                    Case "IMM"
                        OpcodeToHEX = "10000101"
                    Case "DIR"
                        OpcodeToHEX = "10010101"
                    Case "IX"
                        OpcodeToHEX = "10100101"
                    Case "EXT"
                        OpcodeToHEX = "10110101"
                End Select

            Case "EORA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110110"
                    Case "IMM"
                        OpcodeToHEX = "10000110"
                    Case "DIR"
                        OpcodeToHEX = "10010110"
                    Case "IX"
                        OpcodeToHEX = "10100110"
                    Case "EXT"
                        OpcodeToHEX = "10110110"
                End Select

            Case "ADCA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01110111"
                    Case "IMM"
                        OpcodeToHEX = "10000111"
                    Case "DIR"
                        OpcodeToHEX = "10010111"
                    Case "IX"
                        OpcodeToHEX = "10100111"
                    Case "EXT"
                        OpcodeToHEX = "10110111"
                End Select

            Case "CMPA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01111000"
                    Case "IMM"
                        OpcodeToHEX = "10001000"
                    Case "DIR"
                        OpcodeToHEX = "10011000"
                    Case "IX"
                        OpcodeToHEX = "10101000"
                    Case "EXT"
                        OpcodeToHEX = "10111000"
                End Select

            Case "BITA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01111001"
                    Case "IMM"
                        OpcodeToHEX = "10001001"
                    Case "DIR"
                        OpcodeToHEX = "10011001"
                    Case "IX"
                        OpcodeToHEX = "10101001"
                    Case "EXT"
                        OpcodeToHEX = "10111001"
                End Select

            Case "STA"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01111010"
                        'case "IMM"
                        '	opcode_in_hex = "10001010"
                    Case "DIR"
                        OpcodeToHEX = "10011010"
                    Case "IX"
                        OpcodeToHEX = "10101010"
                    Case "EXT"
                        OpcodeToHEX = "10111010"
                End Select

            Case "STS"
                Select Case address_mode
                    'case "IX+" 
                    '	opcode_in_hex = "01111011"
                    'case "IMM"
                    '	opcode_in_hex = "10001011"
                    Case "DIR"
                        OpcodeToHEX = "10011011"
                    Case "IX"
                        OpcodeToHEX = "10101011"
                    Case "EXT"
                        OpcodeToHEX = "10111011"
                End Select

            Case "AIS"
                OpcodeToHEX = "10001011"

            Case "STD"
                Select Case address_mode
                    'case "IX+" 
                    '	opcode_in_hex = "01111100"
                    'case "IMM"
                    '	opcode_in_hex = "10001100"
                    Case "DIR"
                        OpcodeToHEX = "10011100"
                    Case "IX"
                        OpcodeToHEX = "10101100"
                    Case "EXT"
                        OpcodeToHEX = "10111100"
                End Select

            Case "LDS"
                Select Case address_mode
                    'case "IX+" 
                    '	opcode_in_hex = "01111101"
                    Case "IMM"
                        OpcodeToHEX = "10001101"
                    Case "DIR"
                        OpcodeToHEX = "10011101"
                    Case "IX"
                        OpcodeToHEX = "10101101"
                    Case "EXT"
                        OpcodeToHEX = "10111101"
                End Select

            Case "CPD"
                OpcodeToHEX = "01111101"

            Case "SUBD"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01111110"
                    Case "IMM"
                        OpcodeToHEX = "10001110"
                    Case "DIR"
                        OpcodeToHEX = "10011110"
                    Case "IX"
                        OpcodeToHEX = "10101110"
                    Case "EXT"
                        OpcodeToHEX = "10111110"
                End Select

            Case "ADDD"
                Select Case address_mode
                    Case "IX+"
                        OpcodeToHEX = "01111111"
                    Case "IMM"
                        OpcodeToHEX = "10001111"
                    Case "DIR"
                        OpcodeToHEX = "10011111"
                    Case "IX"
                        OpcodeToHEX = "10101111"
                    Case "EXT"
                        OpcodeToHEX = "10111111"
                End Select

            Case "SUBB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000000"
                    Case "DIR"
                        OpcodeToHEX = "11010000"
                    Case "IX"
                        OpcodeToHEX = "11100000"
                    Case "EXT"
                        OpcodeToHEX = "11110000"
                End Select

            Case "SBCB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000001"
                    Case "DIR"
                        OpcodeToHEX = "11010001"
                    Case "IX"
                        OpcodeToHEX = "11100001"
                    Case "EXT"
                        OpcodeToHEX = "11110001"
                End Select

            Case "ADDB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000010"
                    Case "DIR"
                        OpcodeToHEX = "11010010"
                    Case "IX"
                        OpcodeToHEX = "11100010"
                    Case "EXT"
                        OpcodeToHEX = "11110010"
                End Select

            Case "ANDB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000011"
                    Case "DIR"
                        OpcodeToHEX = "11010011"
                    Case "IX"
                        OpcodeToHEX = "11100011"
                    Case "EXT"
                        OpcodeToHEX = "11110011"
                End Select

            Case "LDB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000100"
                    Case "DIR"
                        OpcodeToHEX = "11010100"
                    Case "IX"
                        OpcodeToHEX = "11100100"
                    Case "EXT"
                        OpcodeToHEX = "11110100"
                End Select

            Case "ORB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000101"
                    Case "DIR"
                        OpcodeToHEX = "11010101"
                    Case "IX"
                        OpcodeToHEX = "11100101"
                    Case "EXT"
                        OpcodeToHEX = "11110101"
                End Select

            Case "EORB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000110"
                    Case "DIR"
                        OpcodeToHEX = "11010110"
                    Case "IX"
                        OpcodeToHEX = "11100110"
                    Case "EXT"
                        OpcodeToHEX = "11110110"
                End Select

            Case "ADCB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11000111"
                    Case "DIR"
                        OpcodeToHEX = "11010111"
                    Case "IX"
                        OpcodeToHEX = "11100111"
                    Case "EXT"
                        OpcodeToHEX = "11110111"
                End Select

            Case "CMPB"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11001000"
                    Case "DIR"
                        OpcodeToHEX = "11011000"
                    Case "IX"
                        OpcodeToHEX = "11101000"
                    Case "EXT"
                        OpcodeToHEX = "11111000"
                End Select

            Case "JSR"
                Select Case address_mode
                    'case "IMM"
                    '	opcode_in_hex = "11000000"
                    'Case "DIR"
                    '   opcode_in_hex = "11011001"
                    Case "IX"
                        OpcodeToHEX = "11101001"
                    Case "EXT"
                        OpcodeToHEX = "11111001"
                End Select

            Case "BSR"
                OpcodeToHEX = "11001001"

            Case "STB"
                Select Case address_mode
                    'case "IMM"
                    '	opcode_in_hex = "11001010"
                    Case "DIR"
                        OpcodeToHEX = "11011010"
                    Case "IX"
                        OpcodeToHEX = "11101010"
                    Case "EXT"
                        OpcodeToHEX = "11111010"
                End Select

            Case "STX"
                Select Case address_mode
                    'case "IMM"
                    '	opcode_in_hex = "11001011"
                    Case "DIR"
                        OpcodeToHEX = "11011011"
                    Case "IX"
                        OpcodeToHEX = "11101011"
                    Case "EXT"
                        OpcodeToHEX = "11111011"
                End Select

            Case "AIX"
                OpcodeToHEX = "11001011"

            Case "CPX"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11001100"
                    Case "DIR"
                        OpcodeToHEX = "11011100"
                    Case "IX"
                        OpcodeToHEX = "11101100"
                    Case "EXT"
                        OpcodeToHEX = "11111100"
                End Select

            Case "LDX"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11001101"
                    Case "DIR"
                        OpcodeToHEX = "11011101"
                    Case "IX"
                        OpcodeToHEX = "11101101"
                    Case "EXT"
                        OpcodeToHEX = "11111101"
                End Select

            Case "CPD"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11001110"
                    Case "DIR"
                        OpcodeToHEX = "11011110"
                    Case "IX"
                        OpcodeToHEX = "11101110"
                    Case "EXT"
                        OpcodeToHEX = "11111110"
                End Select

            Case "LDD"
                Select Case address_mode
                    Case "IMM"
                        OpcodeToHEX = "11001111"
                    Case "DIR"
                        OpcodeToHEX = "11011111"
                    Case "IX"
                        OpcodeToHEX = "11101111"
                    Case "EXT"
                        OpcodeToHEX = "11111111"
                End Select

            Case Else
                OpcodeToHEX = "%"
                Exit Function
        End Select

        If OpcodeToHEX = "%" Then
            TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Addresing mode of operation " & asm_opcode & " wasn't recognized." & vbNewLine & _
                vbTab & "Verify the Address or inmidiate value"
            ErrorCounter = ErrorCounter + 1
        Else
            OpcodeToHEX = UCase(Convert.ToString(Convert.ToInt16(OpcodeToHEX, 2), 16))
        End If


    End Function

    Public Function SplitInstructionField(ByRef InstructionRigth As String, ByRef InstructionLeft As String, _
                                          ByVal CharToCompare As String, _
                                          Optional ByRef ReturnRigthField As Boolean = True, _
                                            Optional ByVal WhatReturnWhenError As String = "%")
        Dim SplitLine(0 To 1) As String
        If InstructionRigth.Contains(CharToCompare) Then
            SplitLine = Split(InstructionRigth, CharToCompare, 2)
            SplitLine(0) = Trim(SplitLine(0))
            SplitLine(1) = Trim(SplitLine(1))
        Else
            SplitLine(0) = Trim(InstructionRigth)
            SplitLine(1) = Trim(WhatReturnWhenError)
        End If

        InstructionRigth = SplitLine(0)
        InstructionLeft = SplitLine(1)

        If ReturnRigthField = True Then
            SplitInstructionField = InstructionRigth
        Else
            SplitInstructionField = InstructionLeft
        End If


    End Function

    Public Function FindEquLabels(ByVal label As String) As String

        Dim FirstChar As String
        Dim NoLabel As String = label

        If label.First = "#" Then
            label = label.Trim("#")
            FirstChar = "#"
        ElseIf label.First = "$" Then
            label = label.Trim("$")
            FirstChar = "$"
        Else
            If ToolButton_CISCKER.Checked = True Then
                FirstChar = "$"
            Else
                FirstChar = ""
            End If
        End If

        For j = 0 To EQUcounter - 1
            If EQUarray(j, 0) = label Then
                FindEquLabels = FirstChar & EQUarray(j, 1)
                Exit Function
            End If
        Next

        FindEquLabels = NoLabel
    End Function

    Public Function NumericalBase(ByVal Number As String, ByVal Ciscker As Boolean)
        Dim lastchar As Char = LCase(Number.Last)
        Dim outBase As Byte = 10


        If Ciscker = True Then
            outBase = 16
        Else
            outBase = 10
        End If

        Try
            If lastchar = "h" Then
                Number = Replace(Number, lastchar, "")
                NumericalBase = Convert.ToString(Convert.ToUInt16(Number, 16), outBase)
            ElseIf lastchar = "b" Then
                Number = Replace(Number, lastchar, "")
                NumericalBase = Convert.ToString(Convert.ToUInt16(Number, 2), outBase)
            ElseIf lastchar = "o" Then
                Number = Replace(Number, lastchar, "")
                NumericalBase = Convert.ToString(Convert.ToUInt16(Number, 8), outBase)
            Else
                NumericalBase = Convert.ToString(Convert.ToUInt16(Number, 10), outBase)
            End If
        Catch ex As Exception
            NumericalBase = Number
        End Try
    End Function

    Public Sub CiscAssemblyProcess()

        'CISC Instruction fields
        Dim AddresingMode As String = "%"

        'SECOND PASS GET ALL INFORMATION OF THE INSTRUCTION
        '--------------------------------------------------
        'INSTRUCTION FIELD
        For i = 0 To InstructionsVector.Length - 1     'location counter

            InstructionRigth = InstructionsVector(i)

            '1. Fill all Fields
            '1.1 Trim Comments 
            SplitInstructionField(InstructionRigth, InstructionLeft, ";")

            '1.2 Explicit Addres Mode
            AddresingMode = SplitInstructionField(InstructionRigth, InstructionLeft, ",", False)

            '1.3 Label
            LabelField = SplitInstructionField(InstructionRigth, InstructionLeft, ":")
            If InstructionLeft = "%" Then
                LabelField = "%"
            Else
                InstructionRigth = InstructionLeft
            End If

            '1.4 Operation and Operand
            OperationField = SplitInstructionField(InstructionRigth, InstructionLeft, " ")
            OperandField = InstructionLeft
            If OperandField = "%" Then
                AddresingMode = "INH"
            End If



            '=====================================================

            '2. Get the HEX Operand and implicit addres mode

            '2.1 EQU Operand, Check the EQU list and Find de appropiate Operand
            'Search in EQU vector
            OperandField = FindEquLabels(OperandField)

            If AddresingMode = "%" Then

                '2.2 Address Operand "$"
                If OperandField.First = "$" Then
                    OperandField = Trim(Replace(OperandField, "$", " ")) 'Trim the char "$"

                    'Implicit address mode for address operands

                    Try
                        'Convert operand to two bytes opr
                        OperandInByte = HexToTwoBytes(NumericalBase(OperandField, True))

                        'check for proper hex value
                        Convert.ToInt16(OperandInByte(0), 16)
                        Convert.ToInt16(OperandInByte(1), 16)

                        'if operand > 255 Address mode is EXT
                        If Convert.ToInt16(OperandInByte(1), 16) > 0 Then
                            AddresingMode = "EXT"
                        Else
                            AddresingMode = "DIR"
                        End If

                    Catch ex As Exception
                        TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Operand " & OperandField & " at line " & i & " wasn't recognized."
                        ErrorCounter = ErrorCounter + 1
                    End Try

                    '2.3 Immidiate Operand "#"
                ElseIf OperandField.First = "#" Then
                    OperandField = Trim(Replace(OperandField, "#", " "))
                    AddresingMode = "IMM"
                End If

                'check for relative address operand
                If CheckAddressingMode(OperationField) = "R" Then
                    OperandField = OperandField
                    AddresingMode = "REL"

                ElseIf CheckAddressingMode(OperationField) = "J" Then
                    OperandField = OperandField
                    AddresingMode = "EXT"
                End If

            End If
            '3. Machine Code conversion

            '3.1 opcode conversion

            'Check for valid operation
            If OpcodeToHEX(OperationField, AddresingMode) = "%" Then
                TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Operation " & OperationField & " at line " & i & " wasn't recognized."
                ErrorCounter = ErrorCounter + 1
                System.Media.SystemSounds.Hand.Play()
                ErrorTab.Text = "Error (" & ErrorCounter & ")"
                MessageBox.Show("Epic Fail", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
                ErrorTab.Focus()
                Exit Sub
            Else
                'Get the hexa value
                OperandInByte = HexToTwoBytes(OpcodeToHEX(OperationField, AddresingMode))
                'Save operation in machine code vector
                MachineCode(MemoryAddressCounter) = OperandInByte(0)
                'Save label field in label vector
                LabelArray(MemoryAddressCounter, 0) = LabelField
                'Save operation mnemonic in label vector
                LabelArray(MemoryAddressCounter, 1) = OperationField
                'increase memory address counter to machin code conversion
                MemoryAddressCounter = MemoryAddressCounter + 1
            End If


            '3.2 operand conversion

            '   A. Check for valid operand
            Try
                OperandField = NumericalBase(OperandField, True)
                OperandInByte = HexToTwoBytes(OperandField)
                Convert.ToInt16(OperandInByte(0), 16)
                Convert.ToInt16(OperandInByte(1), 16)
            Catch ex As Exception
                'If no operand, check for inherent operation
                If AddresingMode = "INH" Then
                    OperandInByte(1) = OperandField
                    OperandInByte(0) = "00"
                    'if oerand is label, check for relative or jump operations
                ElseIf AddresingMode = "REL" Or CheckAddressingMode(OperationField) = "J" Then
                    OperandInByte(1) = OperandField
                    OperandInByte(0) = OperandField
                Else 'Other way is an Error
                    TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Operand " & OperandField & " at line " & i & " is not a proper hex value"
                    ErrorCounter = ErrorCounter + 1
                    'Default value for invalid operands
                    OperandInByte(0) = "00"
                    OperandInByte(1) = "00"
                End If
            End Try

            '       B. Write the valid operand in Machine code Vector

            ' If addressing mode is Ext two bytes will be write
            If CheckAddressingMode(OperationField) = "J" Or AddresingMode = "EXT" Then
                MachineCode(MemoryAddressCounter) = OperandInByte(1)
                MemoryAddressCounter = MemoryAddressCounter + 1
                MachineCode(MemoryAddressCounter) = OperandInByte(0)
                MemoryAddressCounter = MemoryAddressCounter + 1

                'If Addressing mode is IMM we need to know how long is the operand
            ElseIf AddresingMode = "IMM" Then
                'If the operand is two bytes...
                If Convert.ToInt16(OperandInByte(1), 16) > 0 Then
                    MachineCode(MemoryAddressCounter) = OperandInByte(1)
                    MemoryAddressCounter = MemoryAddressCounter + 1
                    MachineCode(MemoryAddressCounter) = OperandInByte(0)
                    MemoryAddressCounter = MemoryAddressCounter + 1
                Else 'If the operand is one byte...
                    MachineCode(MemoryAddressCounter) = OperandInByte(0)
                    MemoryAddressCounter = MemoryAddressCounter + 1
                End If

                'If addressign mode is INH no operands will be write
            ElseIf AddresingMode = "INH" Then
                MemoryAddressCounter = MemoryAddressCounter
            Else 'One byte operand is default
                MachineCode(MemoryAddressCounter) = OperandInByte(0)
                MemoryAddressCounter = MemoryAddressCounter + 1
            End If

            'Display Main Table: To show all fields in Summary Box
            TextBox_Summary.Text = TextBox_Summary.Text & i & vbTab & LabelField & vbTab & OperationField & vbTab & OpcodeToHEX(OperationField, AddresingMode) & vbTab & OperandField & vbTab & AddresingMode & vbNewLine
        Next


        'Show Pseudo Machine Code Table: Show the Machine vector and the label Vector. It is useful to know how many bytes the memory need
        'labels are not calculated
        TextBox_Summary.Text = TextBox_Summary.Text & vbNewLine & vbNewLine & " Pseudo Machine Code " & vbNewLine
        For i = 0 To MemoryAddressCounter - 1
            TextBox_Summary.Text = TextBox_Summary.Text & vbNewLine & i & vbTab & LabelArray(i, 0) & vbTab & LabelArray(i, 1) & vbTab & CheckAddressingMode(LabelArray(i, 1)) & vbTab & MachineCode(i)
        Next


        '4. FIND AND CALCULATE LABELS
        For i = 0 To MemoryAddressCounter - 1
            For j = 0 To MemoryAddressCounter - 1
                If MachineCode(i) = LabelArray(j, 0) Then
                    'If the Operation is relative we need to calculate the relative operand (One byte)
                    If CheckAddressingMode(LabelArray(i - 1, 1)) = "R" Then
                        OperandInByte = HexToTwoBytes(Hex(j - (i - 1) - 2))
                        MachineCode(i) = OperandInByte(0)
                    Else 'The Operand is EXT so we write two bytes operand
                        OperandInByte = HexToTwoBytes(Hex(j + OffsetAddress))
                        MachineCode(i) = OperandInByte(1)
                        MachineCode(i + 1) = OperandInByte(0)
                    End If
                End If
            Next
        Next


        '5. WRITE THE MACHINE CODE IN A TEXT BOX TO GENERATE DE PROPER FILE

        MachineCodeGeneration(ToolButton_CISCKER.Checked, ToolButton_Quartus.Checked)


        'Update Error Label to show how many error we have
        ErrorTab.Text = "Error (" & ErrorCounter & ")"
        'Show A Special message if no errors in process
        If ErrorCounter = 0 Then
            TextBox_Error.Text = "Congratulations ¡No Errors! "
            TextBox_Summary.Text = TextBox_Summary.Text & vbNewLine & "Build Success"
            System.Media.SystemSounds.Exclamation.Play()
        End If


    End Sub

    Private Sub MachineCodeGeneration(ByVal CisckerFormat As Boolean, Optional ByVal QuartusFormat As Boolean = True)

        If QuartusFormat = True Then

            If CisckerFormat = True Then

                'Memory information: Is constant
                TextBox_MIF.Text = "WIDTH=8;" & vbNewLine & "DEPTH=32768;" & vbNewLine & "ADDRESS_RADIX=HEX;" & vbNewLine & "DATA_RADIX=HEX;" & vbNewLine & "CONTENT BEGIN" & vbNewLine
                TextBox_MIF.Text = TextBox_MIF.Text & "[" & Hex(0) & ".." & Hex(OffsetAddress - 1) & "]  :  00;" & vbNewLine
                'Write the HEX values from Machine Code vector
                For i = 0 To MemoryAddressCounter - 1
                    Try 'Check for Invalid HEX values
                        Convert.ToInt16(MachineCode(i), 16)
                    Catch ex As Exception
                        'Error Tab
                        TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "Operand " & OperandField & " at line " & i & " is not a proper hex value"
                        'Memory File
                        TextBox_MIF.Text = TextBox_MIF.Text & vbNewLine & vbNewLine & "Build Fail" & vbNewLine & vbNewLine
                        ErrorCounter = ErrorCounter + 1
                        Exit For
                    End Try

                    'Write the Valid HEX values from Machine Code vector
                    TextBox_MIF.Text = TextBox_MIF.Text & Hex(i + OffsetAddress) & " : " & MachineCode(i) & ";" & vbNewLine
                Next

                'MIF Syntax 
                TextBox_MIF.Text = TextBox_MIF.Text & "[" & Hex(MemoryAddressCounter + OffsetAddress) & ".." & "7FFF" & "]  :  00;" & vbNewLine & "END;"


            Else 'RISCKER MIF

                'Memory information: Is constant
                TextBox_MIF.Text = "WIDTH=32;" & vbNewLine & "DEPTH=16384;" & vbNewLine & "ADDRESS_RADIX=DEC;" & vbNewLine & "DATA_RADIX=BIN;" & vbNewLine & "CONTENT BEGIN" & vbNewLine

                For i = 0 To MemoryAddressCounter - 1
                    TextBox_MIF.Text = TextBox_MIF.Text & MachineCode(i) & vbNewLine
                Next

                'Write the default instruction and end the MIF
                'MIF Syntax 
                TextBox_MIF.Text = TextBox_MIF.Text & "[" & (InstructionsVector.Length) & ".." & "16383" & "]  :  00;" & vbNewLine & "END;"
            End If

        Else
            'MEM file generation
            For i = 0 To OffsetAddress - 1
                TextBox_MIF.Text = TextBox_MIF.Text & "00" & vbNewLine
            Next

            For i = 0 To MemoryAddressCounter - 1
                TextBox_MIF.Text = TextBox_MIF.Text & MachineCode(i) & vbNewLine
            Next

            For i = OffsetAddress + MemoryAddressCounter - 1 To 1000
                TextBox_MIF.Text = TextBox_MIF.Text & "00" & vbNewLine
            Next
        End If

    End Sub

    Public Function NameRegisterToBin(ByVal Rx)

        Rx = LCase(Rx)

        'Return the Binary of the register, if insn't in list return Rx (no change)

        Select Case Rx
            Case "r0"
                NameRegisterToBin = "000000"

            Case "rv0"
                NameRegisterToBin = "000001"

            Case "rv1"
                NameRegisterToBin = "000010"

            Case "rv2"
                NameRegisterToBin = "000011"

            Case "rv3"
                NameRegisterToBin = "000100"

            Case "rv4"
                NameRegisterToBin = "000101"

            Case "rv5"
                NameRegisterToBin = "000110"

            Case "rv6"
                NameRegisterToBin = "000111"

            Case "rv7"
                NameRegisterToBin = "001000"

            Case "rp0"
                NameRegisterToBin = "001001"

            Case "rp1"
                NameRegisterToBin = "001010"

            Case "rp2"
                NameRegisterToBin = "001011"

            Case "rp3"
                NameRegisterToBin = "001100"

            Case "rp4"
                NameRegisterToBin = "001101"

            Case "rp5"
                NameRegisterToBin = "001110"

            Case "rp6"
                NameRegisterToBin = "001111"

            Case "rp7"
                NameRegisterToBin = "010000"

            Case "rt0"
                NameRegisterToBin = "010001"

            Case "rt1"
                NameRegisterToBin = "010010"

            Case "rt2"
                NameRegisterToBin = "010011"

            Case "rt3"
                NameRegisterToBin = "010100"

            Case "rt4"
                NameRegisterToBin = "010101"

            Case "rt5"
                NameRegisterToBin = "010110"

            Case "rt6"
                NameRegisterToBin = "010111"

            Case "rt7"
                NameRegisterToBin = "011000"

            Case "rg0"
                NameRegisterToBin = "011001"

            Case "rg1"
                NameRegisterToBin = "011010"

            Case "rg2"
                NameRegisterToBin = "011011"

            Case "rg3"
                NameRegisterToBin = "011100"

            Case "rg4"
                NameRegisterToBin = "011101"

            Case "rg5"
                NameRegisterToBin = "011110"

            Case "rg6"
                NameRegisterToBin = "011111"

            Case "rg7"
                NameRegisterToBin = "100000"

            Case "rg8"
                NameRegisterToBin = "100001"

            Case "rg9"
                NameRegisterToBin = "100010"

            Case "rg10"
                NameRegisterToBin = "100011"

            Case "rg11"
                NameRegisterToBin = "100100"

            Case "rg12"
                NameRegisterToBin = "100101"

            Case "rg13"
                NameRegisterToBin = "100110"

            Case "rg14"
                NameRegisterToBin = "100111"

            Case "rg15"
                NameRegisterToBin = "101000"

            Case "rg16"
                NameRegisterToBin = "101001"

            Case "rg17"
                NameRegisterToBin = "101010"

            Case "rg18"
                NameRegisterToBin = "101011"

            Case "rg19"
                NameRegisterToBin = "101100"

            Case "rg20"
                NameRegisterToBin = "101101"

            Case "rg21"
                NameRegisterToBin = "101110"

            Case "ra0"
                NameRegisterToBin = "101111"

            Case "ra1"
                NameRegisterToBin = "110000"

            Case "ra2"
                NameRegisterToBin = "110001"

            Case "ra3"
                NameRegisterToBin = "110010"

            Case "sp"
                NameRegisterToBin = "110011"

            Case "pr1"
                NameRegisterToBin = "110100"

            Case "pr2"
                NameRegisterToBin = "110101"

            Case "ti1"
                NameRegisterToBin = "110110"

            Case "ti2"
                NameRegisterToBin = "110111"

            Case "eir1"
                NameRegisterToBin = "111000"

            Case "eir2"
                NameRegisterToBin = "111001"

            Case "op"
                NameRegisterToBin = "111010"

            Case "rc"
                NameRegisterToBin = "111011"

            Case "tmr1"
                NameRegisterToBin = "111100"

            Case "tmr2"
                NameRegisterToBin = "111101"

            Case "ip"
                NameRegisterToBin = "111110"

            Case "ipc"
                NameRegisterToBin = "111111"

            Case Else : NameRegisterToBin = Rx

        End Select


    End Function

    Public Function OpcodeRisc(ByVal opr As String, ByVal rd As String, ByVal rs As String, ByVal rt As String, ByVal imm As String) As String

        imm = NumericalBase(imm, False)

        opr = LCase(opr)

        Select Case opr

            Case "add"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000000"

            Case "and"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000001"

            Case "or"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000010"

            Case "xor"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000011"

            Case "nand"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000100"

            Case "nor"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000101"

            Case "sub"
                OpcodeRisc = "0000" & rd & rs & rt & "0000000110"

            Case "neg"
                OpcodeRisc = "0000" & rs & rt & "000000" & "0000000110"

            Case "inc"
                OpcodeRisc = "0000" & rs & rt & "000000" & "0000000111"

            Case "mult"
                OpcodeRisc = "0000" & rd & rs & rt & "0010001000"

            Case "div"
                OpcodeRisc = "0000" & rd & rs & rt & "0011001001"

            Case "rot"
                OpcodeRisc = "0000" & rs & "000000" & rt & "000000" & Str2Bin(imm, 4)

            Case "sll"
                OpcodeRisc = "0000" & rs & "000000" & rt & "000000" & Str2Bin(imm, 4)

            Case "srl"
                OpcodeRisc = "0000" & rs & "000000" & rt & "000000" & Str2Bin(imm, 4)

            Case "sra"
                OpcodeRisc = "0000" & rs & "000000" & rt & "000000" & Str2Bin(imm, 4)

            Case "addi"
                OpcodeRisc = "1000" & rs & rt & Str2Bin(imm, , True)

            Case "andi"
                OpcodeRisc = "1001" & rs & rt & Str2Bin(imm)

            Case "ori"
                OpcodeRisc = "1010" & rs & rt & Str2Bin(imm)

            Case "xori"
                OpcodeRisc = "1011" & rs & rt & Str2Bin(imm)

            Case "nandi"
                OpcodeRisc = "1100" & rs & rt & Str2Bin(imm)

            Case "nori"
                OpcodeRisc = "1101" & rs & rt & Str2Bin(imm)

            Case "multi"
                OpcodeRisc = "1110" & rs & rt & Str2Bin(imm)

            Case "divi"
                OpcodeRisc = "1111" & rs & rt & Str2Bin(imm)

            Case "j"
                OpcodeRisc = "0001" & Str2Bin(imm, 28)

            Case "sw"
                OpcodeRisc = "0010" & rs & rt & Str2Bin(imm)

            Case "lw"
                OpcodeRisc = "0011" & rs & rt & Str2Bin(imm)

            Case "blt"
                OpcodeRisc = "0100" & rt & rs & Str2Bin(imm)

            Case "beq"
                OpcodeRisc = "0101" & rt & rs & Str2Bin(imm)

            Case "jrlw"
                OpcodeRisc = "0110" & rs & rt & Str2Bin(imm)

            Case "jal"
                OpcodeRisc = "0111" & rd & Str2Bin(imm, 22)

            Case Else : OpcodeRisc = "%"

        End Select


    End Function

    Public Function Str2Bin(ByVal strOP As String, Optional ByVal NumOfBits As Byte = 16, Optional ByVal Signed As Boolean = False) As String

        Dim j As Double
        Dim intOP As Integer
        Dim MaxBitRepr As Byte


        If Signed = True Then
            Try
                intOP = CInt(strOP)
                MaxBitRepr = NumOfBits - 1
            Catch ex As Exception
                Str2Bin = "%"
                TextBox_Error.Text = TextBox_Error.Text & ErrorCounter & vbTab & strOP & " isn't a valid operand " & vbNewLine
                ErrorCounter = ErrorCounter + 1
                Exit Function
            End Try

        Else
            Try
                intOP = Convert.ToUInt32(strOP)
                MaxBitRepr = NumOfBits
            Catch ex As Exception
                Str2Bin = "%"
                TextBox_Error.Text = TextBox_Error.Text & ErrorCounter & vbTab & strOP & " isn't a valid operand " & vbNewLine
                ErrorCounter = ErrorCounter + 1
                Exit Function
            End Try

        End If

        'Check for overload errors
        Str2Bin = ""
        If intOP < (-2 ^ MaxBitRepr) Then
            Str2Bin = "min"
            Exit Function

        ElseIf intOP > ((2 ^ MaxBitRepr) - 1) Then
            Str2Bin = "max"
            Exit Function

            'check for sign
        ElseIf Signed = True And intOP < 0 Then
            Str2Bin = "1"
            intOP = intOP + 2 ^ (MaxBitRepr)
            j = 2 ^ (MaxBitRepr - 1)
        Else
            j = 2 ^ (NumOfBits - 1)
        End If

        'Binary conversion
        Do While j >= 1
            Str2Bin = Str2Bin & Fix(intOP / j)
            intOP = intOP - j * Fix(intOP / j)
            j = j / 2
        Loop

        'Check the width
        If Str2Bin.Length < NumOfBits Then
            Str2Bin = "0" & Str2Bin
        End If

    End Function

    Public Sub RiscAssemblyProcess()

        'RISC Instruction fields
        Dim Rd As String = "%"  'Register destination
        Dim Rs As String = "%"  'Register Source
        Dim Rt As String = "%"  'Register "t" second source ("t" is next of "s")
        Dim RiscInstruction As String = "%"

        'For Summary Box
        TextBox_Summary.Text = "PC" & vbTab & "Operation" & vbTab & vbTab & "Rd" & vbTab & "Rs" & vbTab & "Rt" & vbTab & "Imm/Target/shamt" & vbNewLine

        'Save and trim Labels 
        For i = 0 To InstructionsVector.Length - 1
            InstructionRigth = InstructionsVector(i)
            LabelField = SplitInstructionField(InstructionRigth, InstructionLeft, ":", , InstructionRigth)
            InstructionsVector(i) = InstructionLeft
            LabelArray(i, 0) = LabelField
        Next


        'ASSEMBLY PROCESS
        For i = 0 To InstructionsVector.Length - 1
            TextBox_Summary.Text = TextBox_Summary.Text & i
            InstructionRigth = InstructionsVector(i)

            '1. Trism Comments
            SplitInstructionField(InstructionRigth, InstructionLeft, ";")

            '2. Get all instruction fields

            '2.2 Imm or Target Operand

            'Resolve Operand
            OperandField = SplitInstructionField(InstructionRigth, InstructionLeft, "#", False)

            'check for labels targets
            For j = 0 To InstructionsVector.Length - 1
                If OperandField = LabelArray(j, 0) Then
                    OperandField = j
                End If
            Next

            '2.3 Get the Operation
            OperationField = SplitInstructionField(InstructionRigth, InstructionLeft, " ")
            InstructionRigth = InstructionLeft
            InstructionRigth = Trim(Replace(InstructionRigth, ",", " "))

            '2.4 Get the Rd Operand
            Rd = SplitInstructionField(InstructionRigth, InstructionLeft, " ", , InstructionRigth)
            InstructionRigth = InstructionLeft

            '2.5 Get the Rs Operand
            Rs = SplitInstructionField(InstructionRigth, InstructionLeft, " ")
            InstructionRigth = InstructionLeft

            '2.6 Get the Rt Operand
            Rt = SplitInstructionField(InstructionRigth, InstructionLeft, " ")
            InstructionRigth = InstructionLeft

            If Rt = "%" Then
                Rt = Rs
                Rs = Rd
            End If

            'Show Imm in summary textbox
            TextBox_Summary.Text = TextBox_Summary.Text & vbTab & OperationField & vbTab
            TextBox_Summary.Text = TextBox_Summary.Text & vbTab & Rd
            TextBox_Summary.Text = TextBox_Summary.Text & vbTab & Rs
            TextBox_Summary.Text = TextBox_Summary.Text & vbTab & Rt
            TextBox_Summary.Text = TextBox_Summary.Text & vbTab & OperandField & vbNewLine

            'Find the EQU labels values
            Rd = FindEquLabels(Rd)
            Rs = FindEquLabels(Rs)
            Rt = FindEquLabels(Rt)
            OperandField = FindEquLabels(OperandField)


            'Convert the operands in Binary expression
            Rd = NameRegisterToBin(Rd)
            Rs = NameRegisterToBin(Rs)
            Rt = NameRegisterToBin(Rt)


            'Build the binary instruction
            RiscInstruction = OpcodeRisc(OperationField, Rd, Rs, Rt, OperandField)

            'Check for Build errors
            Try
                Convert.ToInt32(RiscInstruction, 2)
            Catch ex As Exception
                TextBox_Error.Text = TextBox_Error.Text & ErrorCounter & " The Instruction " & OperationField & " at line " & i & " wasn't recognized." & _
                "Verify the name of the registers or immediate's value" & vbNewLine
                TextBox_Error.Text = TextBox_Error.Text & vbTab & RiscInstruction & vbNewLine
                ErrorCounter = ErrorCounter + 1
            End Try

            'Write the binary instruction in the MIF
            MachineCode(i) = i & ":" & RiscInstruction & ";"
            MemoryAddressCounter = MemoryAddressCounter + 1

        Next

        MachineCodeGeneration(ToolButton_CISCKER.Checked, ToolButton_Quartus.Checked)


        'Update Error Label to show how many errors were found
        ErrorTab.Text = "Error (" & ErrorCounter & ")"
        'Show A Special message if no errors in process
        If ErrorCounter = 0 Then
            TextBox_Error.Text = "Congratulations ¡No Errors! "
            TextBox_Summary.Text = TextBox_Summary.Text & vbNewLine & "Build Success"
            System.Media.SystemSounds.Exclamation.Play()
        Else
            System.Media.SystemSounds.Hand.Play()
            MessageBox.Show("Epic Fail", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End If
    End Sub

    Public Sub ClearAllTexBoxAndVars()
        'Clear all
        TextBox_Summary.Clear()
        TextBox_MIF.Clear()
        TextBox_Error.Clear()
        TextBox_System.Clear()
        EQUcounter = 0
        MemoryAddressCounter = 0
        ErrorCounter = 0
        Array.Clear(EQUarray, 0, EQUcounter)
        Array.Clear(LabelArray, 0, LabelArray.Length)
    End Sub

    Private Sub ToolButton_Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_Run.Click

        'Make a machine code file 

        'Clear all
        ClearAllTexBoxAndVars()

        'FIRST PASS
        '--------------------------------------------------
        'GET THE INSTRUCTIONS (Whithout empty lines, comments or directives)

        Try
            'Trim empty lines, comments or directives and resolve directives
            InstructionsVector = TrimLinesWhithoutOperations(Split(TextBox_Assembler.Text, vbLf))

        Catch ex As Exception
            TextBox_Error.Text = TextBox_Error.Text & vbNewLine & "No code in File"
            ErrorCounter = ErrorCounter + 1
            ErrorTab.Text = "Error (" & ErrorCounter & ")"
            ErrorTab.Focus()
            System.Media.SystemSounds.Hand.Play()
            MessageBox.Show("Epic Fail", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub
        End Try

        'TO SHOW IN TEXTBOX
        TextBox_Summary.Text = TextBox_Summary.Text & vbNewLine & "PC" & vbTab & "Label" & vbTab & "Opcode" & vbTab & vbTab & "Operand" & vbTab & "Address Mode" & vbTab & "Comments" & vbNewLine
        TextBox_Error.Text = "ERROR" & vbNewLine

        'save files
        If FileNameAssembler = "" Then
        Else
            WriteFile(FileNameAssembler, TextBox_Assembler.Text)
        End If

        'SECOND PASS GET ALL INFORMATION OF THE INSTRUCTION
        '--------------------------------------------------
        'INSTRUCTION FIELD

        If ToolButton_CISCKER.Checked = True Then
            CiscAssemblyProcess()
            Exit Sub
        Else
            RiscAssemblyProcess()
            Exit Sub
        End If

    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        'MessageBox.Show("Assebler Soft" & vbNewLine & "Jose Pablo Pinilla" & vbNewLine & "Alfredo Gualdrón" & vbNewLine & "Copyright ©  2011", "About")
        XISCKER_AboutBox.Show()
    End Sub

    Private Sub ToolButton_Help_ButtonClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_Help.ButtonClick
        XISCKER_AboutBox.Show()
    End Sub

    Private Sub ToolButton_Programmer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_Programmer.Click

        'save all changes
        ToolButton_SaveFile.PerformButtonClick()
        XISCKER_Programmer.Show()
    End Sub

    Private Sub ToolButton_WorkSpace_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolButton_WorkSpace.Click
        LoadWorkSpace()
        LoadAsmSession()
    End Sub

    Private Sub ToolButton_Observer_Click(sender As System.Object, e As System.EventArgs) Handles ToolButton_Observer.Click
        If ToolButton_CISCKER.Checked = True Then
            IsCISCKER = True
            XISCKER_Observer.Show()
            Exit Sub
        Else
            IsCISCKER = False
            XISCKER_Observer.Show()
            Exit Sub
        End If

    End Sub
End Class