﻿Public Class XISCKER_Programmer
    Dim projectname As String = ""
    Dim FamilyName As String = ""
    Dim BinFolder As String = ""
    Dim hwcable As String = ""
    Dim compile_cmd As String = ""

    Private Sub XisckerProgrammer_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.FormClosing
        'Save RadioButton and compile check status before close the form
        SavePrgmSession()
    End Sub

    Private Sub XisckerProgrammer_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Load the last Options Selected
        LoadLastPrgmSession()
    End Sub

    Private Sub CreateItemsFiles(Optional ByVal WhatFile As String = "")

        Dim item As String

        Select Case (WhatFile)
            Case "AlteraFamily"
                'Altera Family
                item = "CycloneIVE"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item", item)

            Case "AlteraCable"
                'Altera Cable
                item = "USB-Blaster"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item", item)

            Case "XilinxFamily"
                'Xilinx Family
                item = "xc3s700a-fg484-4"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\XilinxFamilyItems.item", item)

            Case Else
                'Altera Family
                item = "CycloneIVE"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item", item)

                'Altera Cable
                item = "USB-Blaster"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item", item)

                'Xilinx Family
                item = "xc3s700a-fg484-4"
                XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\XilinxFamilyItems.item", item)
        End Select
    End Sub

    Private Sub UpdateItems()

        Dim items() As String
        Dim item As String
        item = XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item")
        items = Split(item, vbNewLine)

        If RadioButton_Altera.Checked = True Then
            For i = 0 To items.Length - 1
                If ComboBox_Family.Text <> items(i) Then
                    XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item", item & vbNewLine & ComboBox_Family.Text)
                End If
            Next

            item = XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item")
            items = Split(item, vbNewLine)
            For i = 0 To items.Length - 1
                If ComboBox_Cable.Text <> items(i) Then
                    XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item", item & vbNewLine & ComboBox_Cable.Text)
                End If
            Next
        Else
            For i = 0 To items.Length - 1
                If ComboBox_Family.Text <> items(i) Then
                    XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\XilinxFamilyItems.item", item & vbNewLine & ComboBox_Family.Text)
                End If
            Next
        End If

    End Sub

    Private Sub SavePrgmSession()
        Dim session As String = RadioButton_Altera.Checked & vbNewLine & BinFolder & vbNewLine & FamilyName & vbNewLine _
                                & hwcable & vbNewLine & projectname & vbNewLine & CheckBox_UpdateMemory.Checked _
                                & vbNewLine & CheckBox_CompileProject.Checked

        XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\LastPrgmSession.bak", session)

        UpdateItems()

    End Sub

    Private Sub LoadLastPrgmSession()
        Dim session()

        Try
            session = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\LastPrgmSession.bak"), vbNewLine)

            BinFolder = session(1)
            TextBox_ProductFolder.Text = BinFolder

            FamilyName = session(2)
            hwcable = session(3)

            projectname = session(4)
            TextBox_ProjectName.Text = projectname

            If session(0) = "True" Then
                RadioButton_Altera.PerformClick()
            Else
                RadioButton_Xilinx.PerformClick()
            End If

            CheckBox_UpdateMemory.Checked = True

            If session(6) = "True" Then
                CheckBox_CompileProject.Checked = True
            Else
                CheckBox_CompileProject.Checked = False
            End If

            If session(5) = "False" Then
                CheckBox_UpdateMemory.Checked = False
            End If

        Catch ex As Exception
            SavePrgmSession()
        End Try
    End Sub

    Private Sub CheckBox_CompileProject_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox_CompileProject.CheckedChanged
        'If compile project the memory will be update
        If CheckBox_CompileProject.Checked = True Then
            CheckBox_UpdateMemory.Checked = True
            CheckBox_UpdateMemory.Enabled = False
        Else 'Only update memory whitout compiling
            CheckBox_UpdateMemory.Enabled = True
        End If
    End Sub

    Private Sub Button_BrowseProjectName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_BrowseProjectName.Click

        'configuring openfiledialog dependig of selected company
        'ALTERA
        If RadioButton_Altera.Checked = True Then
            OpenFileDialog_Prg.Filter = "Altera Project Files (*.qpf)|*.qpf"
            OpenFileDialog_Prg.DefaultExt = ".qpf"
            OpenFileDialog_Prg.Title = "Altera Project"
            OpenFileDialog_Prg.FileName = ".qpf"
            OpenFileDialog_Prg.ShowDialog()
        Else 'XILINX
            OpenFileDialog_Prg.Filter = "Verilog Files (*.v)|*.v"
            OpenFileDialog_Prg.DefaultExt = ".v"
            OpenFileDialog_Prg.Title = "Xilinx Project"
            OpenFileDialog_Prg.FileName = ".v"
            OpenFileDialog_Prg.ShowDialog()
        End If


    End Sub

    Private Sub OpenFileDialog_Prg_FileOk(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog_Prg.FileOk
        'Trim the extention of The project name 
        If RadioButton_Altera.Checked = True Then
            projectname = Replace(OpenFileDialog_Prg.FileName, ".qpf", "")
        Else
            projectname = Replace(OpenFileDialog_Prg.FileName, ".v", "")
        End If
        'Show the project name in the textbox
        TextBox_ProjectName.Text = projectname
    End Sub

    Private Sub Button_ProductFolder_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ProductFolder.Click
        'Show the folder dialog to find the proper path to execute commands scripts
        If RadioButton_Altera.Checked = True Then
            FolderBrowserDialog_Prg.Description = "Select the Alera bin folder" & vbNewLine & "Example: c:\Altera\11.1\quartus\bin"
        Else
            FolderBrowserDialog_Prg.Description = "Select the Xilinx nt folder" & vbNewLine & "Example: C:\Xilinx\12.4\ISE_DS\ISE\bin\nt"
        End If

        FolderBrowserDialog_Prg.ShowDialog()
        'Update bin folder
        If FolderBrowserDialog_Prg.SelectedPath <> "" Then
            BinFolder = FolderBrowserDialog_Prg.SelectedPath
        End If
        'Show the selected folder in textbox
        TextBox_ProductFolder.Text = BinFolder


    End Sub

    Private Sub RadioButton_Altera_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton_Altera.CheckedChanged
        'Update fields depending of selected company
        Dim FamilyItems() As String
        Dim CableItems() As String


        TextBox_ProjectName.Text = projectname
        ComboBox_Family.Text = FamilyName
        TextBox_ProductFolder.Text = BinFolder
        ComboBox_Cable.Text = hwcable

        'ALTERA
        If RadioButton_Altera.Checked = True Then
            'Update labels
            Label_ProductFolder.Text = "altera\...\quartus\bin"
            Label_Family.Text = "Family:"
            Label_ProjectName.Text = "Project Name:"
            'Update combobox items for cable field
            Try
                CableItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item"), vbNewLine)
            Catch ex As Exception
                CreateItemsFiles()
                CableItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item"), vbNewLine)
            End Try

            ComboBox_Cable.Items.Clear()
            ComboBox_Cable.Items.AddRange(CableItems)
            ComboBox_Cable.Text = ComboBox_Cable.Items.Item(0)
            ComboBox_Cable.Enabled = True
            'Update combox items for family field
            Try
                FamilyItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item"), vbNewLine)
            Catch ex As Exception
                CreateItemsFiles("AlteraFamily")
                FamilyItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraFamilyItems.item"), vbNewLine)
                CreateItemsFiles("AlteraCable")
                CableItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\AlteraCableItems.item"), vbNewLine)
            End Try

            ComboBox_Family.Items.Clear()
            ComboBox_Family.Items.AddRange(FamilyItems)
            ComboBox_Family.Text = ComboBox_Family.Items.Item(0)
            'Update Texboxs with the last fields saved for ALTERA

        Else 'XILINX
            'Updat labels
            Label_ProductFolder.Text = "Xilinx\...\ISE\bin\nt"
            Label_Family.Text = "Device:"
            Label_ProjectName.Text = "Top Module:"
            'Update combobox for cable field
            ComboBox_Cable.Text = "Auto"
            ComboBox_Cable.Enabled = False
            'Update combobox items for family field
            Try
                FamilyItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\XilinxFamilyItems.item"), vbNewLine)
            Catch ex As Exception
                CreateItemsFiles("XilinxFamily")
                FamilyItems = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\XilinxFamilyItems.item"), vbNewLine)
            End Try

            ComboBox_Family.Items.Clear()
            ComboBox_Family.Items.AddRange(FamilyItems)
            ComboBox_Family.Text = ComboBox_Family.Items.Item(0)
            'Update Texboxs with the last fields saved for XILINX

        End If
    End Sub

    Private Sub XProgrammer()
        'Build the batch file with the proper paths and command to compile and program the device


        'check if compile or memory update
        If RadioButton_Altera.Checked = True Then
            If CheckBox_CompileProject.Checked = True Then
                compile_cmd = Global.XISCKER_IDE.My.Resources.AlteraCompile
            Else
                compile_cmd = Global.XISCKER_IDE.My.Resources.AlteraUpDateMif
            End If
        Else
            compile_cmd = Global.XISCKER_IDE.My.Resources.XilinxCompile
        End If

        'Update the variables
        FamilyName = ComboBox_Family.Text
        hwcable = ComboBox_Cable.Text

        'Replace the variables from command template in a new string
        compile_cmd = Replace(compile_cmd, "binpath", BinFolder)
        compile_cmd = Replace(compile_cmd, "projectname", projectname)
        compile_cmd = Replace(compile_cmd, "familyname", FamilyName)
        compile_cmd = Replace(compile_cmd, "hwcable", hwcable)
        compile_cmd = Replace(compile_cmd, "Xilinxprgm", XISCKER_ASM.WorkSpaceFolder & "\sys\Xilinxprgm")
        'write the string in .bat extention file
        XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\Command.bat", compile_cmd)
    End Sub

    Private Sub Button_Program_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Program.Click
        'To show busy satatus
        Button_Program.Text = "Compiling"
        Button_Program.Enabled = False

        'Check the company selected
        If RadioButton_Altera.Checked = True Then
            XProgrammer()
        Else
            XProgrammer()
            'Update the paths of program script, only for xilinx
            XISCKER_ASM.WriteFile(XISCKER_ASM.WorkSpaceFolder & "\sys\Xilinxprgm.cmd", Replace(Global.XISCKER_IDE.My.Resources.Xilinxprgm, "projectname", projectname))
        End If

        'Launch the .bat file with all commands, and save the result in a .txt file
        Shell(XISCKER_ASM.WorkSpaceFolder & "\sys\Command.bat" & " > " & XISCKER_ASM.WorkSpaceFolder & "\sys\ResultCmd.txt", AppWinStyle.Hide, True)

        'save the fields in a file, to load in the next time
        SavePrgmSession()

        'Write the result of shell in system tab, and write the errors in error tab
        GetErrorFromResultCmd()

        'Enable program button
        Button_Program.Text = "Program"
        Button_Program.Enabled = True

        'Close From
        Me.Close()

        System.Media.SystemSounds.Exclamation.Play()
        MessageBox.Show("Compiling and Programing is done" & vbNewLine & "Check the 'Error' tab to be sure no errors occurred", "", MessageBoxButtons.OK, MessageBoxIcon.Warning)

    End Sub

    Private Sub GetErrorFromResultCmd()
        Dim log() As String = Split(XISCKER_ASM.ReadFile(XISCKER_ASM.WorkSpaceFolder & "\sys\ResultCmd.txt"), vbCrLf)
        XISCKER_ASM.ErrorTab.Text = "Error (*)"
        For i = 0 To log.Length - 1

            If log(i).Contains(XISCKER_ASM.WorkSpaceFolder) = True Then
                log(i) = ""
            End If

            If log(i).Contains("ECHO") = True Then
                log(i) = ""
            End If

            If log(i) = "" Then

            ElseIf log(i).First = "*" Then
                XISCKER_ASM.TextBox_Error.Text &= vbNewLine & log(i)
            ElseIf LCase(log(i)).Contains("error") = True Then
                XISCKER_ASM.TextBox_Error.Text &= vbNewLine & log(i)
            End If

            XISCKER_ASM.TextBox_System.Text &= vbNewLine & log(i)
        Next

    End Sub

End Class